﻿DECLARE
	cmd VARCHAR2(2048);
	DeleteRecordCmdTemplate VARCHAR2(4000) :=
		'DELETE FROM "tmp_OperationData"
		WHERE "RecordId" IN (SELECT "Id" FROM "{TableName}")
		AND "TableName" = ''{TableName}''';
	UpdateCmdTemplate VARCHAR2(4000) :=
		'UPDATE "tmp_OperationData"
		SET "Status" = ''Ready''
		WHERE "TableName" = ''{TableName}''';
	DeleteCmdTemplate VARCHAR2(4000) :=
		'DELETE FROM "tmp_OperationData"
		WHERE "TableName" = ''{TableName}''';
	TYPE TableNamelist IS TABLE OF VARCHAR2(50);
	TableNames TableNamelist;
	TYPE OperationDataCursor IS REF CURSOR;
	l_OperationDataCursor OperationDataCursor;
BEGIN
	OPEN l_OperationDataCursor FOR 'SELECT "TableName" FROM "tmp_OperationData" WHERE "Status" IS NULL';
		FETCH l_OperationDataCursor BULK COLLECT INTO TableNames;
	CLOSE l_OperationDataCursor;
	
	FOR i IN TableNames.FIRST .. TableNames.LAST
	LOOP
		IF "tspkg_Update77To78"."fn_IsObjectExist"(TableNames(i)) != 0 THEN
			cmd := REPLACE(DeleteRecordCmdTemplate, '{TableName}', TableNames(i));
			EXECUTE IMMEDIATE cmd;

			cmd := REPLACE(UpdateCmdTemplate, '{TableName}', TableNames(i));
			EXECUTE IMMEDIATE cmd;
		ELSE
			cmd := REPLACE(DeleteCmdTemplate, '{TableName}', TableNames(i));
			EXECUTE IMMEDIATE cmd;
		END IF;
	END LOOP;
END;

