BEGIN
	IF ("tspkg_Update77To78"."fn_IsRowsExist"('SysLic') = 0) THEN
		RETURN;
	END IF;
  IF "tspkg_Update77To78"."fn_IsObjectExist"('SysDashboard_backup') = 0 THEN
    RETURN;
  END IF;

  EXECUTE IMMEDIATE 'UPDATE "SysDashboard" sd
  SET (sd."Caption", sd."Position", sd."ViewConfig", sd."Items") = (
    SELECT sd_b."Caption", sd_b."Position", sd_b."ViewConfig", sd_b."Items"
    FROM "SysDashboard_backup" sd_b
    WHERE sd."Id" = sd_b."Id")
	WHERE EXISTS (SELECT "Id" 
		FROM "SysDashboard_backup" sd_b
		WHERE sd."Id" = sd_b."Id")';
  
  EXECUTE IMMEDIATE 'DROP TABLE "SysDashboard_backup"';
END;
